#include "imageaes.h"

static unsigned char key[32];
static int keytype;

int hex2int(const char* hex) {
	int result;
	if(hex[0]>='0' && hex[0]<='9')result=hex[0]-'0';
	else if(hex[0]>='A' && hex[0]<='F')result=hex[0]-'A'+10;
	else if(hex[0]>='a' && hex[0]<='f')result=hex[0]-'a'+10;
	else return -1;
	result<<=4;
	if(hex[1]>='0' && hex[1]<='9')result|=hex[1]-'0';
	else if(hex[1]>='A' && hex[1]<='F')result|=hex[1]-'A'+10;
	else if(hex[1]>='a' && hex[1]<='f')result|=hex[1]-'a'+10;
	else return -1;
	return result;
}

BOOL CALLBACK PassDlgProc(HWND hDlg,UINT message,
                          WPARAM wParam,LPARAM lParam)
{
	char* passtext;
	int length;
	int i;
	int temp;

	switch(message) {
		case WM_INITDIALOG:
			if(password.password) {
				SetWindowText(GetDlgItem(hDlg,IDC_EDITPASS),password.password);
			}
			if(password.showpassword) {
				SendMessage(GetDlgItem(hDlg,IDC_SHOWPASS),BM_SETCHECK,1,0);
			} else {
				SendMessage(GetDlgItem(hDlg,IDC_EDITPASS),
					EM_SETPASSWORDCHAR,'*',0);
				InvalidateRect(GetDlgItem(hDlg,IDC_EDITPASS),NULL,FALSE);
			}
			if(password.passwordishex) {
				SendMessage(GetDlgItem(hDlg,IDC_INPUTKEY),
					BM_SETCHECK,1,0);
			} else {
				SendMessage(GetDlgItem(hDlg,IDC_INPUTPASS),
					BM_SETCHECK,1,0);
			}
			return TRUE;
		case WM_COMMAND:
			switch(LOWORD(wParam)) {
				case IDC_SHOWPASS:
					if(SendMessage(GetDlgItem(hDlg,IDC_SHOWPASS),
							BM_GETCHECK,0,0)) {
						/*pX[h\*/
						SendMessage(GetDlgItem(hDlg,IDC_EDITPASS),
							EM_SETPASSWORDCHAR,0,0);
					} else {
						/*pX[h\*/
						SendMessage(GetDlgItem(hDlg,IDC_EDITPASS),
							EM_SETPASSWORDCHAR,'*',0);
					}
					InvalidateRect(GetDlgItem(hDlg,IDC_EDITPASS),NULL,FALSE);
					return TRUE;
				case IDOK:
					length=GetWindowTextLength(GetDlgItem(hDlg,IDC_EDITPASS));
					passtext=HeapAlloc(GetProcessHeap(),0,length+1);
					GetWindowText(GetDlgItem(hDlg,IDC_EDITPASS),passtext,length+1);
					if(SendMessage(GetDlgItem(hDlg,IDC_INPUTKEY),BM_GETCHECK,0,0)) {
						/*16ǐ*/
						if(length!=32 && length!=48 && length!=64) {
							MessageBox(hDlg,"̒słB",
								"G[",MB_OK | MB_ICONWARNING);
							return TRUE;
						}
						for(i=0;i<length;i+=2) {
							temp=hex2int(&passtext[i]);
							if(temp<0) {
								MessageBox(hDlg,"słB",
									"G[",MB_OK | MB_ICONWARNING);
								return TRUE;
							}
							key[i>>1]=temp;
						}
						switch(length) {
							case 32:keytype=AES_128;break;
							case 48:keytype=AES_192;break;
							case 64:keytype=AES_256;break;
						}
					} else {
						GetMD5(passtext,length,key);
						keytype=AES_128;
					}
					if(password.password)HeapFree(GetProcessHeap(),0,password.password);
					password.password=passtext;
					password.passwordishex=SendMessage(GetDlgItem(hDlg,IDC_INPUTKEY),BM_GETCHECK,0,0);
					password.showpassword=SendMessage(GetDlgItem(hDlg,IDC_SHOWPASS),BM_GETCHECK,0,0);
					EndDialog(hDlg,TRUE);
					return TRUE;
				case IDCANCEL:
					EndDialog(hDlg,FALSE);
					return TRUE;
			}
			return FALSE;
		case WM_CLOSE:
			EndDialog(hDlg,FALSE);
			return TRUE;
	}
	return FALSE;
}

int GetAesKey(HWND hWnd) {
	return DialogBox(hInst,"PASSWORDDLG",hWnd,PassDlgProc);
}

bmp_t* EncryptBmp(HWND hWnd,bmp_t* bmp) {
	bmp_t* bmpResult;
	unsigned char inputbuf[16];
	unsigned char outputbuf[16];
	int x,y;
	int i,j;
	if(!GetAesKey(hWnd))return NULL;
	bmpResult=bmpCopy(bmp);
	if(!bmpResult)return NULL;
	for(y=0;y<=getBmpHeight(bmp)-4;y+=4) {
		for(x=0;x<=getBmpWidth(bmp)-4;x+=4) {
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).r;
				}
			}
			/*Í*/
			aes_encript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).r=outputbuf[(i<<2)+j];
				}
			}
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).g;
				}
			}
			/*Í*/
			aes_encript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).g=outputbuf[(i<<2)+j];
				}
			}
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).b;
				}
			}
			/*Í*/
			aes_encript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).b=outputbuf[(i<<2)+j];
				}
			}
		}
	}
	return bmpResult;
}

bmp_t* DecryptBmp(HWND hWnd,bmp_t* bmp) {
	bmp_t* bmpResult;
	unsigned char inputbuf[16];
	unsigned char outputbuf[16];
	int x,y;
	int i,j;
	if(!GetAesKey(hWnd))return NULL;
	bmpResult=bmpCopy(bmp);
	if(!bmpResult)return NULL;
	for(y=0;y<=getBmpHeight(bmp)-4;y+=4) {
		for(x=0;x<=getBmpWidth(bmp)-4;x+=4) {
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).r;
				}
			}
			/**/
			aes_decript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).r=outputbuf[(i<<2)+j];
				}
			}
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).g;
				}
			}
			/**/
			aes_decript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).g=outputbuf[(i<<2)+j];
				}
			}
			/*̓obt@̏*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					inputbuf[(i<<2)+j]=getBmpXY(bmp,x+i,y+j).b;
				}
			}
			/**/
			aes_decript(outputbuf,inputbuf,key,keytype);
			/*obt@o*/
			for(i=0;i<4;i++) {
				for(j=0;j<4;j++) {
					getBmpXY(bmpResult,x+i,y+j).b=outputbuf[(i<<2)+j];
				}
			}
		}
	}
	return bmpResult;
}
