#include <windows.h>

/*O[oϐ*/
static unsigned int state[4];
static unsigned int count_[2];
static unsigned char buffer[64];
static unsigned char digest[16];

/*vg^Cv錾*/
static unsigned int sr(unsigned int x,unsigned int n);
static unsigned int FF(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac);
static unsigned int GG(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac);
static unsigned int HH(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac);
static unsigned int II(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac);
static void MD5Update(const unsigned char* inputx,unsigned int inputLen);
static void MD5Final(void);
static void MD5Transform(const unsigned char* block,unsigned int offset);
static void Encode(unsigned char* output,const unsigned int* inputx,unsigned int lenx);

/*EVtg(Zp(>>)ł͂Ȃ_(>>>)Vtgɑ)*/
static unsigned int sr(unsigned int x,unsigned int n) {
	unsigned int y=0;
	unsigned int z=0;
    if(n==0) {
        return x;
	} else {
        y=x & 0x7FFFFFFF;
        if(n==31) {
            z=0;
		} else {
            z=y>>n;
        }
        if(y!=x) {
			/*ŕ\ꍇɁA̒lł*/
            z=z | 1<<(31-n);
        }
        return z;
	}
}

static unsigned int FF(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac) {
    a=a+((b & c) | ((~ b) & d))+x+ac;
    a=a<<s | sr(a,32-s);
    return a+b;
}

static unsigned int GG(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac) {
    a=a+((b & d) | (c & (~ d)))+x+ac;
    a=a<<s | sr(a,32-s);
    return a+b;
}

static unsigned int HH(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac) {
    a=a+(b ^ c ^ d)+x+ac;
    a=a<<s | sr(a,32-s);
    return a+b;
}

static unsigned int II(unsigned int a,unsigned int b,unsigned int c,unsigned int d,unsigned int x,unsigned int s,unsigned int ac) {
    a=a+(c ^ (b | (~ d)))+x+ac;
    a=a<<s | sr(a,32-s);
    return a+b;
}

static void MD5Update(const unsigned char* inputx,unsigned int inputLen) {
	int i=0;
	unsigned int index=0;
	unsigned int partLen=0;

    index=sr(count_[0],3) & 0x3F;
    
    count_[0]=count_[0]+inputLen*8;
    if(count_[0]<inputLen*8) {
        count_[1]=count_[1]+1;
	}

    count_[1]=count_[1]+sr(inputLen,29);

    partLen=64-index;

    if(inputLen>=partLen) {
		memcpy(buffer+index,inputx,partLen);
        MD5Transform(buffer,0);

        for(i=partLen;(int)i<=(int)inputLen-64;i+=64) {
            MD5Transform(inputx,i);
        }
        index=0;
    } else {
        i=0;
    }

	memcpy(buffer+index,inputx+i,inputLen-i);
}

static void MD5Final(void) {
	unsigned char bits[8]={0};
	unsigned int index=0;
	unsigned int padLen=0;
	unsigned char PADDING[64]={0};

    Encode(bits,count_,8);

    index=sr(count_[0],3) & 0x3F;
    if(index<56) {
        padLen=56-index;
    } else {
        padLen=120-index;
    }
    
    PADDING[0]=0x80;
    
    MD5Update(PADDING,padLen);

    MD5Update(bits,8);

    Encode(digest,state,16);
}

static void MD5Transform(const unsigned char* block,unsigned int offset) {
	unsigned int a=0;
	unsigned int b=0;
	unsigned int c=0;
	unsigned int d=0;
	unsigned int i=0;
	unsigned int j=0;
	unsigned int k=0;
	unsigned int x[16]={0};
    
    a=state[0];
    b=state[1];
    c=state[2];
    d=state[3];
    
	/*XDecode߂ĂяôłPJĂяoȂ
	  Œڏ܂B*/
    i=0;
    j=0;
    while(1) {
		if(j>=64)break;
        k=j+offset;
        x[i]=*((unsigned int*)(block+k));
        i=i+1;
        j=j+4;
    }

    /*Round 1*/
    a=FF(a,b,c,d,x[0],7,0xD76AA478);   /* 1 S11*/
    d=FF(d,a,b,c,x[1],12,0xE8C7B756);  /* 2 S12*/
    c=FF(c,d,a,b,x[2],17,0x242070DB);  /* 3 S13*/
    b=FF(b,c,d,a,x[3],22,0xC1BDCEEE);  /* 4 S14*/
    a=FF(a,b,c,d,x[4],7,0xF57C0FAF);   /* 5 S11*/
    d=FF(d,a,b,c,x[5],12,0x4787C62A);  /* 6 S12*/
    c=FF(c,d,a,b,x[6],17,0xA8304613);  /* 7 S13*/
    b=FF(b,c,d,a,x[7],22,0xFD469501);  /* 8 S14*/
    a=FF(a,b,c,d,x[8],7,0x698098D8);   /* 9 S11*/
    d=FF(d,a,b,c,x[9],12,0x8B44F7AF);  /*10 S12*/
    c=FF(c,d,a,b,x[10],17,0xFFFF5BB1); /*11 S13*/
    b=FF(b,c,d,a,x[11],22,0x895CD7BE); /*12 S14*/
    a=FF(a,b,c,d,x[12],7,0x6B901122);  /*13 S11*/
    d=FF(d,a,b,c,x[13],12,0xFD987193); /*14 S12*/
    c=FF(c,d,a,b,x[14],17,0xA679438E); /*15 S13*/
    b=FF(b,c,d,a,x[15],22,0x49B40821); /*16 S14*/

    /*Round 2*/
    a=GG(a,b,c,d,x[1],5,0xF61E2562);   /*17 S21*/
    d=GG(d,a,b,c,x[6],9,0xC040B340);   /*18 S22*/
    c=GG(c,d,a,b,x[11],14,0x265E5A51); /*19 S23*/
    b=GG(b,c,d,a,x[0],20,0xE9B6C7AA);  /*20 S24*/
    a=GG(a,b,c,d,x[5],5,0xD62F105D);   /*21 S21*/
    d=GG(d,a,b,c,x[10],9,0x2441453);   /*22 S22*/
    c=GG(c,d,a,b,x[15],14,0xD8A1E681); /*23 S23*/
    b=GG(b,c,d,a,x[4],20,0xE7D3FBC8);  /*24 S24*/
    a=GG(a,b,c,d,x[9],5,0x21E1CDE6);   /*25 S21*/
    d=GG(d,a,b,c,x[14],9,0xC33707D6);  /*26 S22*/
    c=GG(c,d,a,b,x[3],14,0xF4D50D87);  /*27 S23*/
    b=GG(b,c,d,a,x[8],20,0x455A14ED);  /*28 S24*/
    a=GG(a,b,c,d,x[13],5,0xA9E3E905);  /*29 S21*/
    d=GG(d,a,b,c,x[2],9,0xFCEFA3F8);   /*30 S22*/
    c=GG(c,d,a,b,x[7],14,0x676F02D9);  /*31 S23*/
    b=GG(b,c,d,a,x[12],20,0x8D2A4C8A); /*32 S24*/

    /*Round 3*/
    a=HH(a,b,c,d,x[5],4,0xFFFA3942);   /*33 S31*/
    d=HH(d,a,b,c,x[8],11,0x8771F681);  /*34 S32*/
    c=HH(c,d,a,b,x[11],16,0x6D9D6122); /*35 S33*/
    b=HH(b,c,d,a,x[14],23,0xFDE5380C); /*36 S34*/
    a=HH(a,b,c,d,x[1],4,0xA4BEEA44);   /*37 S31*/
    d=HH(d,a,b,c,x[4],11,0x4BDECFA9);  /*38 S32*/
    c=HH(c,d,a,b,x[7],16,0xF6BB4B60);  /*39 S33*/
    b=HH(b,c,d,a,x[10],23,0xBEBFBC70); /*40 S34*/
    a=HH(a,b,c,d,x[13],4,0x289B7EC6);  /*41 S31*/
    d=HH(d,a,b,c,x[0],11,0xEAA127FA);  /*42 S32*/
    c=HH(c,d,a,b,x[3],16,0xD4EF3085);  /*43 S33*/
    b=HH(b,c,d,a,x[6],23,0x4881D05);   /*44 S34*/
    a=HH(a,b,c,d,x[9],4,0xD9D4D039);   /*45 S31*/
    d=HH(d,a,b,c,x[12],11,0xE6DB99E5); /*46 S32*/
    c=HH(c,d,a,b,x[15],16,0x1FA27CF8); /*47 S33*/
    b=HH(b,c,d,a,x[2],23,0xC4AC5665);  /*48 S34*/

    /*Round 4*/
    a=II(a,b,c,d,x[0],6,0xF4292244);   /*49 S41*/
    d=II(d,a,b,c,x[7],10,0x432AFF97);  /*50 S42*/
    c=II(c,d,a,b,x[14],15,0xAB9423A7); /*51 S43*/
    b=II(b,c,d,a,x[5],21,0xFC93A039);  /*52 S44*/
    a=II(a,b,c,d,x[12],6,0x655B59C3);  /*53 S41*/
    d=II(d,a,b,c,x[3],10,0x8F0CCC92);  /*54 S42*/
    c=II(c,d,a,b,x[10],15,0xFFEFF47D); /*55 S43*/
    b=II(b,c,d,a,x[1],21,0x85845DD1);  /*56 S44*/
    a=II(a,b,c,d,x[8],6,0x6FA87E4F);   /*57 S41*/
    d=II(d,a,b,c,x[15],10,0xFE2CE6E0); /*58 S42*/
    c=II(c,d,a,b,x[6],15,0xA3014314);  /*59 S43*/
    b=II(b,c,d,a,x[13],21,0x4E0811A1); /*60 S44*/
    a=II(a,b,c,d,x[4],6,0xF7537E82);   /*61 S41*/
    d=II(d,a,b,c,x[11],10,0xBD3AF235); /*62 S42*/
    c=II(c,d,a,b,x[2],15,0x2AD7D2BB);  /*63 S43*/
    b=II(b,c,d,a,x[9],21,0xEB86D391);  /*64 S44*/

    state[0]=state[0]+a;
    state[1]=state[1]+b;
    state[2]=state[2]+c;
    state[3]=state[3]+d;

	/*ZeroMemory(x,64)*/
}

static void Encode(unsigned char* output,const unsigned int* inputx,unsigned int lenx) {
	unsigned int i=0;
	unsigned int j=0;
    i=0;
    j=0;
    while(1) {
		if(j>=lenx)break;
        output[j]=inputx[i]; /*& 0xFF*/
        output[j+1]=sr(inputx[i],8); /*& 0xFF*/
        output[j+2]=sr(inputx[i],16); /*& 0xFF*/
        output[j+3]=sr(inputx[i],24); /*& 0xFF*/
        i=i+1;
        j=j+4;
    }
}

void GetMD5(const unsigned char* Buf,unsigned int Size,unsigned char* MD5) {
	unsigned int lenx=0;
	ZeroMemory(MD5,16);

	ZeroMemory(count_,8);
	ZeroMemory(buffer,64);
	ZeroMemory(digest,16);
    if(Size==0xFFFFFFFF) {
		lenx=lstrlen(Buf);
	} else {
		lenx=Size;
	}
    
    state[0]=0x67452301;
    state[1]=0xEFCDAB89;
    state[2]=0x98BADCFE;
    state[3]=0x10325476;
    MD5Update(Buf,lenx);
    MD5Final();

	memcpy(MD5,digest,16);
}

#if 0
void PrintMD5(const unsigned char* MD5,unsigned char* HexDec) {
	unsigned int i=0;
	char s[33]={0};
    for(i=0;i<=15;i++) {
		wsprintf(s+i*2,"%02X",MD5[i]);
    }
	memcpy(HexDec,s,32);
}
#endif
